#!/bin/sh
ldcfg=5.0-c2.config
lxcfg=.config

cd linux

export ARCH=arm64
export LOCALVERSION="+c2"

make LOCALVERSION="${LOCALVERSION}" ARCH=${ARCH} defconfig

if [ ! -e config-0 ]; then
  cp -p .config config-0
fi

if [ -e arch/arm64/configs/odroidc2_defconfig ]; then
  make LOCALVERSION="${LOCALVERSION}" ARCH=${ARCH} odroidc2_defconfig

  cp -p .config $ldcfg
fi

if false; then
  wget -N https://raw.githubusercontent.com/nxmyoz/c2-overlay/d629105f86281fac940a4814436431e5a66df601/c2.config
  cp -p c2.config $lxcfg

  echo 'CONFIG_QCOM_FALKOR_ERRATUM_E1041=y' >> $lxcfg
  echo 'CONFIG_UNMAP_KERNEL_AT_EL0=y' >> $lxcfg
  echo 'CONFIG_HARDEN_BRANCH_PREDICTOR=y' >> $lxcfg
  echo 'CONFIG_MESON_GX_PM_DOMAINS=y' >> $lxcfg
  echo 'CONFIG_MESON_MX_SOCINFO=y' >> $lxcfg

  make LOCALVERSION="${LOCALVERSION}" ARCH=${ARCH} oldconfig
fi

lxcfg=.config
cp -p $ldcfg $lxcfg

sed -i 's|^CONFIG_LOCALVERSION_AUTO=.*|# CONFIG_LOCALVERSION_AUTO is not set|g' $lxcfg
sed -i 's|^CONFIG_DEFAULT_HOSTNAME=.*|CONFIG_DEFAULT_HOSTNAME="(none)"|g' $lxcfg

sed -i 's|^CONFIG_DEBUG_INFO=y|# CONFIG_DEBUG_INFO is not set|g' $lxcfg

sed -i 's|^CONFIG_STMMAC_ETH=m|CONFIG_STMMAC_ETH=y|g' $lxcfg
sed -i 's|^CONFIG_STMMAC_PLATFORM=m|CONFIG_STMMAC_PLATFORM=y|g' $lxcfg
sed -i 's|^CONFIG_DWMAC_GENERIC=m|CONFIG_DWMAC_GENERIC=y|g' $lxcfg
sed -i 's|^CONFIG_DWMAC_IPQ806X=m|CONFIG_DWMAC_IPQ806X=y|g' $lxcfg
sed -i 's|^CONFIG_DWMAC_MESON=m|CONFIG_DWMAC_MESON=y|g' $lxcfg
sed -i 's|^CONFIG_DWMAC_ROCKCHIP=m|CONFIG_DWMAC_ROCKCHIP=y|g' $lxcfg
sed -i 's|^CONFIG_DWMAC_SUNXI=m|CONFIG_DWMAC_SUNXI=y|g' $lxcfg

make LOCALVERSION="${LOCALVERSION}" ARCH=${ARCH} oldconfig

cd ..

echo OK
